int DistanceSensor(){
  
  //Local variables used only in this function
  unsigned long TimeUsed;
  unsigned long Wait;
  unsigned long WaitExtra;
  unsigned long TimeOpen;
  bool Detected;
  long Duration;
  int Distance;

  TimeUsed = micros(); //Reads how long the arduino have been on in microseconds.

  //Writes the local variables into global variables for monitoring
  DetectedMonitor = Detected;
  DistanceMonitor = Distance;

  //Make the ultrasonic sensor send out a sonic wave and starts two timers.
  //It is activated after 12 microseconds as the timer is exceeded and the function restarts.
  if (WaitExtra < TimeUsed){
    digitalWrite(TrigPin,HIGH); //Sends out a sonic wave
    Wait = TimeUsed + 10; //Takes the current time and adds 10 microseconds to create a timer
    WaitExtra = TimeUsed + 12; //Takes the current time and adds 12 to create a timer
  }

  //Turns off the sonic wave and reads how long it took for it to return.
  //Afterwards it calculates the distance it have traveled.
  //The distance is calculated in cm. 
  if (Wait >= TimeUsed){
    digitalWrite(TrigPin,LOW); // Stops the sonic wave
    Duration = pulseIn(EchoPin,HIGH); //Reads how long it took for the wave to return in microseconds.
    Distance = Duration*0.034/2; //Calculates the distance
  }

  //Checks if anyone is within a certain distance.
  //This can be changed depending on when you want it to trigger.
  //Remember this can't be less than 2 cm (0.79 inches) unless you use a different sensor.
  if ((Distance >= 10) && (Distance <= 30)){
    Detected = 1; //Something is detected
  
  }
  else{
    Detected = 0; //Nothing has been detected
  
  }

  //Allows the Distance_Close to be set if someone if within the distance set.
  //Refreshes if something is detected again.
  if (Detected == 1){
    TimeOpen = TimeUsed + 4000000; //Refreshes or sets the time that must pass to reset Distance_Close.
  }

  //Sets Distance_Close to 1, if the time set in detected hasn't been exceed.
  if (TimeOpen > TimeUsed){
    Distance_Close = 1;  
  }

  //Sets Distance_Close to 0, if the time set in detected has been exceed. 
  if (TimeOpen <= TimeUsed){
    Distance_Close = 0;
  }

}
